#include "..\C-Engine\CEngine.hpp"
#include "generateur.hpp"
#include "monstres.hpp"
#include "GUI.hpp"
#include "Perso.hpp"

int Jeu()
{

        //*************Sprites*************\\

        #include "Sprites.hpp"

        //*************Object*************\\

        Object * Perso = new Object;
        Perso->GetTransform()->SetXY( 20, 20 );
        Perso->GetRender()->SetRender( A_Perso , 9);
        Perso->AffectTag("Perso");
        Perso->AddRigidBody();

        Control * ScriptPerso = new Control;
        Perso->AffectScript(ScriptPerso);

        Object * epee = new Object;
        epee->GetRender ()->SetRender (A_epee);
        ScriptPerso->p_epee = epee;

        //***********Generateur************\\

        MonsterPattern P_Slime("Slime",A_Slime,3,10,10,0);
        MonsterPattern P_Tab[]={P_Slime};



        MonsterPattern P_SacPV("SacPV",A_SacPV,3,10,10,-1);
        MonsterPattern P_Tab1[]={P_SacPV};

        Object * GenerateurSlime1 = new Object;
        Generateur * ScriptGenerateur1 = new Generateur;
        GenerateurSlime1->AffectScript(ScriptGenerateur1);

        Object * GenerateurSlime2 = new Object;
        Generateur * ScriptGenerateur2 = new Generateur;
        GenerateurSlime2->AffectScript(ScriptGenerateur2);

        Object * GenerateurSacPV = new Object;
        Generateur * ScriptGenerateurSacPV = new Generateur;
        GenerateurSacPV->AffectScript(ScriptGenerateurSacPV);

        ScriptGenerateur1->SetBox(0,156,210,419);
        ScriptGenerateur1->ShowBox();
        ScriptGenerateur1->SetTab(1,P_Tab);

        ScriptGenerateur2->SetBox(322,419,308,419);
        ScriptGenerateur2->SetTab(1,P_Tab);

        ScriptGenerateurSacPV->SetBox(266,419,0,56);
        ScriptGenerateurSacPV->SetTab(1,P_Tab1);

        //*************Map*************\\

        Level * mapPrincipal = new Level;
        mapPrincipal->SetMap(tileset , M_mapprincipal, tileprop , 14 , 14 ,30,30);

        Level * maison1 = new Level;
        maison1->SetMap(tilesethouse, M_maison1 , tileprophouse , 14 , 14 , 15 , 6);

        Level * maison2 = new Level;
        maison2->SetMap(tilesethouse, M_maison2 , tileprophouse , 14 , 14 , 9 , 6);

        Level * maison3 = new Level;
        maison3->SetMap(tilesethouse, M_maison3 , tileprophouse , 14 , 14 , 11 , 6);

        Level * world[]={mapPrincipal,maison1,maison2,maison3};

        Object * Trigger1 = new Object; Trigger1->GetTransform()->SetXY(170,97);   Trigger1->AddRigidBody();Trigger1->GetRigidBody()->UseFixeBody(10,2);Trigger1->AffectTag("T1");
        Object * Trigger2 = new Object; Trigger2->GetTransform()->SetXY(30,1);      Trigger2->AddRigidBody();Trigger2->GetRigidBody()->UseFixeBody(10,2);Trigger2->AffectTag("T2");
        Object * Trigger3 = new Object; Trigger3->GetTransform()->SetXY(198,97);   Trigger3->AddRigidBody();Trigger3->GetRigidBody()->UseFixeBody(10,2);Trigger3->AffectTag("T3");
        Object * Trigger4 = new Object; Trigger4->GetTransform()->SetXY(170,1);     Trigger4->AddRigidBody();Trigger4->GetRigidBody()->UseFixeBody(10,2);Trigger4->AffectTag("T4");
        Object * Trigger5 = new Object; Trigger5->GetTransform()->SetXY(58,83);     Trigger5->AddRigidBody();Trigger5->GetRigidBody()->UseFixeBody(10,2);Trigger5->AffectTag("T5");
        Object * Trigger6 = new Object; Trigger6->GetTransform()->SetXY(58,1);      Trigger6->AddRigidBody();Trigger6->GetRigidBody()->UseFixeBody(10,2);Trigger6->AffectTag("T6");
        Object * Trigger7 = new Object; Trigger7->GetTransform()->SetXY(72,125);    Trigger7->AddRigidBody();Trigger7->GetRigidBody()->UseFixeBody(10,2);Trigger7->AffectTag("T7");
        Object * Trigger8 = new Object; Trigger8->GetTransform()->SetXY(114,1);     Trigger8->AddRigidBody();Trigger8->GetRigidBody()->UseFixeBody(10,2);Trigger8->AffectTag("T8");

        //*************Moteur*************\\


        Engine Game;

        Game.SetLevel(world,4);

        Game.AddObject(GenerateurSlime1,0);
        Game.AddObject(GenerateurSlime2,0);
        Game.AddObject(GenerateurSacPV,0);

        Game.AddObject(Perso , 0);
        Game.AddObject(epee , 0);

        Game.AddObject(Trigger1,0);
        Game.AddObject(Trigger2,1);
        Game.AddObject(Trigger3,0);
        Game.AddObject(Trigger4,1);
        Game.AddObject(Trigger5,0);
        Game.AddObject(Trigger6,2);
        Game.AddObject(Trigger7,0);
        Game.AddObject(Trigger8,3);

        Game.StartGame();


        return 1;
}

extern "C"
{
int AddIn_main(int isAppli, unsigned short OptionNum)
{
    Jeu();
    return 1;
}
#pragma section _BR_Size


unsigned long BR_Size;
#pragma section


#pragma section _TOP

int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section
}


